<template>
  <div id="app" class="container" v-if="countries != null">
    <div class="row">
      <input
        type="text"
        placeholder="Enter Capital Here"
        class="shadow-lg my-2 bg-white rounded"
        v-model="filter"
      />
      <div class="table-responsive ">
        <table class="table table-striped table-borderless">
          <thead class="thead-dark">
            <tr>
              <th scope="col">Country</th>
              <th scope="col">Capital</th>
              <th scope="col">Region</th>
              <th scope="col">Flag</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(country, index) in filterByCapital" :key="index">
              <td>{{ country.name }}</td>
              <td>{{ country.capital }}</td>
              <td>{{ country.region }}</td>
              <td>
                <img
                  :src="country.flag"
                  alt=""
                  style="width:50px; height:auto;"
                />
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
  <div class="container mt-5" v-else>
    <div><spinner size="lg"></spinner></div>
  </div>
</template>

<script >
import axios from "axios";
import spinner from "vue-simple-spinner";

export default {
  name: "App",
  data() {
    return {
      filter: "",
      countries: null,
    };
  },
  methods: {
    highlightMatches(text) {
      const matchExists = text
        .toLowerCase()
        .includes(this.filter.toLowerCase());
      if (!matchExists) return text;

      const re = new RegExp(this.filter, "ig");
      return text.replace(
        re,
        (matchedText) => `<strong>${matchedText}</strong>`
      );
    },
    makeRequest() {
      axios
        .get("https://restcountries.eu/rest/v2/all")
        .then((response) => (this.apiResult = response));
    },
  },
  components: {
    spinner,
  },
  computed: {
    console: () => console,
    window: () => window,

    filterByCapital() {
      return this.countries.filter((country) => {
        const capital = country.capital.toString().toLowerCase();
        const searchTerm = this.filter.toLowerCase();
        return capital.includes(searchTerm);
      });
    },
  },
  mounted: function() {
    axios.get("https://restcountries.eu/rest/v2/all").then((response) => {
      this.countries = response.data;
    });
  },
};
</script>

<style>
</style>
